diff --git a/src/main/java/net/minecraft/core/block/BlockJukeBox.java b/src/main/java/net/minecraft/core/block/BlockJukeBox.java
index 4ecbe18b0..4d2c5b06e 100644
--- a/src/main/java/net/minecraft/core/block/BlockJukeBox.java
+++ b/src/main/java/net/minecraft/core/block/BlockJukeBox.java
@@ -7,6 +7,7 @@ package net.minecraft.core.block;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntityRecordPlayer;
@@ -21,7 +22,7 @@ public class BlockJukeBox extends BlockTileEntity
     }
 
     @Override
-    public boolean blockActivated(World world, int x, int y, int z, EntityPlayer player)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced)
     {
         if(world.getBlockMetadata(x, y, z) == 0)
         {
diff --git a/src/main/java/net/minecraft/core/block/BlockLanternFirefly.java b/src/main/java/net/minecraft/core/block/BlockLanternFirefly.java
index 9fa4b9588..689087a28 100644
--- a/src/main/java/net/minecraft/core/block/BlockLanternFirefly.java
+++ b/src/main/java/net/minecraft/core/block/BlockLanternFirefly.java
@@ -85,7 +85,7 @@ public class BlockLanternFirefly extends Block{
     }
 
     @Override
-    public boolean blockActivated(World world, int x, int y, int z, EntityPlayer player)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced)
     {
         world.setBlockRaw(x, y, z, 0);
         world.playSoundAtEntity(player, player, "random.pop", 0.2F, 0.5f);
diff --git a/src/main/java/net/minecraft/core/block/BlockLeavesCacao.java b/src/main/java/net/minecraft/core/block/BlockLeavesCacao.java
index 87693f8af..0fdba8fcf 100644
--- a/src/main/java/net/minecraft/core/block/BlockLeavesCacao.java
+++ b/src/main/java/net/minecraft/core/block/BlockLeavesCacao.java
@@ -48,13 +48,13 @@ public class BlockLeavesCacao extends BlockLeavesBase implements IBonemealable {
     }
 
     @Override
-    public void onBlockClicked(World world, int x, int y, int z, EntityPlayer player)
+    public void onBlockLeftClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xHit, double yHit)
     {
-        blockActivated(world, x, y, z, player);
+        onBlockRightClicked(world, x, y, z, player, null, 0.0, 0.0);
     }
 
     @Override
-    public boolean blockActivated(World world, int x, int y, int z, EntityPlayer player)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced)
     {
         int meta = world.getBlockMetadata(x, y, z);
         int decayData = meta & 0x0F;
@@ -70,7 +70,7 @@ public class BlockLeavesCacao extends BlockLeavesBase implements IBonemealable {
             world.scheduleBlockUpdate(x, y, z, leavesCacao.id, tickRate());
             return true;
         }
-        return super.blockActivated(world, x, y, z, player);
+        return super.onBlockRightClicked(world, x, y, z, player, side, xPlaced, yPlaced);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/block/BlockLeavesCherryFlowering.java b/src/main/java/net/minecraft/core/block/BlockLeavesCherryFlowering.java
index faa4f1e7f..0b99fdac4 100644
--- a/src/main/java/net/minecraft/core/block/BlockLeavesCherryFlowering.java
+++ b/src/main/java/net/minecraft/core/block/BlockLeavesCherryFlowering.java
@@ -32,13 +32,13 @@ public class BlockLeavesCherryFlowering extends BlockLeavesCherry implements IBo
     }
 
     @Override
-    public void onBlockClicked(World world, int x, int y, int z, EntityPlayer player)
+    public void onBlockLeftClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xHit, double yHit)
     {
-        blockActivated(world, x, y, z, player);
+        onBlockRightClicked(world, x, y, z, player, null, 0.0, 0.0);
     }
 
     @Override
-    public boolean blockActivated(World world, int x, int y, int z, EntityPlayer player)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced)
     {
         int meta = world.getBlockMetadata(x, y, z);
         int decayData = meta & 0x0F;
@@ -54,7 +54,7 @@ public class BlockLeavesCherryFlowering extends BlockLeavesCherry implements IBo
             world.scheduleBlockUpdate(x, y, z, leavesCherryFlowering.id, tickRate());
             return true;
         }
-        return super.blockActivated(world, x, y, z, player);
+        return super.onBlockRightClicked(world, x, y, z, player, side, xPlaced, yPlaced);
 
     }
 
diff --git a/src/main/java/net/minecraft/core/block/BlockLever.java b/src/main/java/net/minecraft/core/block/BlockLever.java
index ab833806a..1cb905685 100644
--- a/src/main/java/net/minecraft/core/block/BlockLever.java
+++ b/src/main/java/net/minecraft/core/block/BlockLever.java
@@ -189,15 +189,15 @@ public class BlockLever extends Block
     }
 
     @Override
-    public void onBlockClicked(World world, int x, int y, int z, EntityPlayer player)
+    public void onBlockLeftClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xHit, double yHit)
     {
     	if(!Item.hasTag(player.getCurrentEquippedItem(), ItemTags.PREVENT_LEFT_CLICK_INTERACTIONS)) {
-    		blockActivated(world, x, y, z, player);
+    		onBlockRightClicked(world, x, y, z, player, null, 0.0, 0.0);
     	}
     }
 
     @Override
-    public boolean blockActivated(World world, int x, int y, int z, EntityPlayer player)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced)
     {
         int l = world.getBlockMetadata(x, y, z);
         int i1 = l & 15;
diff --git a/src/main/java/net/minecraft/core/block/BlockMeshGold.java b/src/main/java/net/minecraft/core/block/BlockMeshGold.java
index 8241f1ad1..feac5ea56 100644
--- a/src/main/java/net/minecraft/core/block/BlockMeshGold.java
+++ b/src/main/java/net/minecraft/core/block/BlockMeshGold.java
@@ -7,6 +7,7 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
 public class BlockMeshGold extends BlockTileEntity{
@@ -35,7 +36,7 @@ public class BlockMeshGold extends BlockTileEntity{
         return true;
     }
     @Override
-    public boolean blockActivated(World world, int x, int y, int z, EntityPlayer player)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced)
     {
         TileEntityMeshGold meshGold = (TileEntityMeshGold) world.getBlockTileEntity(x, y, z);
         ItemStack heldItem = player.getHeldItem();
diff --git a/src/main/java/net/minecraft/core/block/BlockMobSpawner.java b/src/main/java/net/minecraft/core/block/BlockMobSpawner.java
index 77f5efeda..8091527ec 100644
--- a/src/main/java/net/minecraft/core/block/BlockMobSpawner.java
+++ b/src/main/java/net/minecraft/core/block/BlockMobSpawner.java
@@ -23,7 +23,7 @@ public class BlockMobSpawner extends BlockTileEntity
     }
 
     @Override
-    public boolean blockActivated(World world, int x, int y, int z, EntityPlayer player) {
+    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced) {
         if (player.getGamemode() != Gamemode.creative) {
             return false;
         }
diff --git a/src/main/java/net/minecraft/core/block/BlockNote.java b/src/main/java/net/minecraft/core/block/BlockNote.java
index a67449bb4..22e27adc0 100644
--- a/src/main/java/net/minecraft/core/block/BlockNote.java
+++ b/src/main/java/net/minecraft/core/block/BlockNote.java
@@ -7,6 +7,7 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.sound.SoundCategory;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntityNote;
@@ -39,7 +40,7 @@ public class BlockNote extends BlockTileEntity
     }
 
     @Override
-    public boolean blockActivated(World world, int x, int y, int z, EntityPlayer player)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced)
     {
         if(world.isClientSide)
         {
@@ -54,7 +55,7 @@ public class BlockNote extends BlockTileEntity
     }
 
     @Override
-    public void onBlockClicked(World world, int x, int y, int z, EntityPlayer player)
+    public void onBlockLeftClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xHit, double yHit)
     {
         if(world.isClientSide)
         {
diff --git a/src/main/java/net/minecraft/core/block/BlockOreRedstone.java b/src/main/java/net/minecraft/core/block/BlockOreRedstone.java
index 2c3bf3034..3feaebfaa 100644
--- a/src/main/java/net/minecraft/core/block/BlockOreRedstone.java
+++ b/src/main/java/net/minecraft/core/block/BlockOreRedstone.java
@@ -7,6 +7,7 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Color;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.client.util.helper.Colors;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
@@ -39,10 +40,10 @@ public class BlockOreRedstone extends Block
     }
 
     @Override
-    public void onBlockClicked(World world, int x, int y, int z, EntityPlayer player)
+    public void onBlockLeftClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xHit, double yHit)
     {
         lightRedstone(world, x, y, z);
-        super.onBlockClicked(world, x, y, z, player);
+        super.onBlockLeftClicked(world, x, y, z, player, side, xHit, yHit);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/block/BlockPumpkin.java b/src/main/java/net/minecraft/core/block/BlockPumpkin.java
index adae9d701..ba00a02a0 100644
--- a/src/main/java/net/minecraft/core/block/BlockPumpkin.java
+++ b/src/main/java/net/minecraft/core/block/BlockPumpkin.java
@@ -9,6 +9,7 @@ import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.tool.ItemToolSword;
 import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
 public class BlockPumpkin extends BlockRotatableHorizontal
@@ -22,7 +23,7 @@ public class BlockPumpkin extends BlockRotatableHorizontal
         this.isCarvable = isCarvable;
     }
     @Override
-    public boolean blockActivated(World world, int x, int y, int z, EntityPlayer player) {
+    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced) {
         if (!isCarvable) return false;
         ItemStack heldItem = player.getHeldItem();
         if (heldItem != null && heldItem.getItem() instanceof ItemToolSword){
diff --git a/src/main/java/net/minecraft/core/block/BlockRedstoneRepeater.java b/src/main/java/net/minecraft/core/block/BlockRedstoneRepeater.java
index 7722ed4f6..518b6d4e1 100644
--- a/src/main/java/net/minecraft/core/block/BlockRedstoneRepeater.java
+++ b/src/main/java/net/minecraft/core/block/BlockRedstoneRepeater.java
@@ -157,7 +157,7 @@ public class BlockRedstoneRepeater extends Block
     }
 
     @Override
-    public boolean blockActivated(World world, int x, int y, int z, EntityPlayer player)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced)
     {
         int l = world.getBlockMetadata(x, y, z);
         int i1 = (l & 0xc) >> 2;
diff --git a/src/main/java/net/minecraft/core/block/BlockRope.java b/src/main/java/net/minecraft/core/block/BlockRope.java
index e55537a66..3b4843561 100644
--- a/src/main/java/net/minecraft/core/block/BlockRope.java
+++ b/src/main/java/net/minecraft/core/block/BlockRope.java
@@ -8,6 +8,7 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.ItemToolShears;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
@@ -65,7 +66,7 @@ public class BlockRope
         setBlockBounds(minX, minY, minZ, maxX, maxY, maxZ);
     }
     @Override
-    public boolean blockActivated(World world, int x, int y, int z, EntityPlayer player)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced)
     {
         ItemStack heldItem = player.getHeldItem();
         if (heldItem != null && heldItem.getItem() instanceof ItemToolShears){
diff --git a/src/main/java/net/minecraft/core/block/BlockSeat.java b/src/main/java/net/minecraft/core/block/BlockSeat.java
index 1eb172196..c6141a2fa 100644
--- a/src/main/java/net/minecraft/core/block/BlockSeat.java
+++ b/src/main/java/net/minecraft/core/block/BlockSeat.java
@@ -7,6 +7,7 @@ import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
 public class BlockSeat
@@ -19,7 +20,7 @@ public class BlockSeat
     }
 
     @Override
-    public boolean blockActivated(World world, int x, int y, int z, EntityPlayer player) {
+    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced) {
         if (world.isBlockNormalCube(x, y + 1, z)) {
             return false;
         }
diff --git a/src/main/java/net/minecraft/core/block/BlockSign.java b/src/main/java/net/minecraft/core/block/BlockSign.java
index 62efa5712..c6c706203 100644
--- a/src/main/java/net/minecraft/core/block/BlockSign.java
+++ b/src/main/java/net/minecraft/core/block/BlockSign.java
@@ -5,6 +5,7 @@ import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.entity.TileEntity;
@@ -166,7 +167,7 @@ public class BlockSign extends BlockTileEntity
         return new ItemStack[] { new ItemStack(Item.sign) };
     }
     @Override
-    public boolean blockActivated(World world, int x, int y, int z, EntityPlayer player) {
+    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced) {
         TileEntitySign tileentitysign = (TileEntitySign)world.getBlockTileEntity(x, y, z);
         if(tileentitysign != null && tileentitysign.getIsEditable(player))
         {
diff --git a/src/main/java/net/minecraft/core/block/BlockSlab.java b/src/main/java/net/minecraft/core/block/BlockSlab.java
index 6baeb3387..e04b5018a 100644
--- a/src/main/java/net/minecraft/core/block/BlockSlab.java
+++ b/src/main/java/net/minecraft/core/block/BlockSlab.java
@@ -153,9 +153,9 @@ public class BlockSlab extends Block
         modelBlock.updateTick(world, x, y, z, rand);
     }
     @Override
-    public boolean blockActivated(World world, int x, int y, int z, EntityPlayer player)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced)
     {
-        return modelBlock.blockActivated(world, x, y, z, player);
+        return modelBlock.onBlockRightClicked(world, x, y, z, player, side, xPlaced, yPlaced);
     }
     @Override
     public void onBlockDestroyedByExplosion(World world, int x, int y, int z)
@@ -200,9 +200,9 @@ public class BlockSlab extends Block
     }
     
     @Override
-    public void onBlockClicked(World world, int x, int y, int z, EntityPlayer player)
+    public void onBlockLeftClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xHit, double yHit)
     {
-        modelBlock.onBlockClicked(world, x, y, z, player);
+        modelBlock.onBlockLeftClicked(world, x, y, z, player, side, xHit, yHit);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/block/BlockStairs.java b/src/main/java/net/minecraft/core/block/BlockStairs.java
index bcae219a6..d0ebaaf7c 100644
--- a/src/main/java/net/minecraft/core/block/BlockStairs.java
+++ b/src/main/java/net/minecraft/core/block/BlockStairs.java
@@ -187,9 +187,9 @@ public class BlockStairs extends Block
     }
 
     @Override
-    public void onBlockClicked(World world, int x, int y, int z, EntityPlayer player)
+    public void onBlockLeftClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xHit, double yHit)
     {
-        modelBlock.onBlockClicked(world, x, y, z, player);
+        modelBlock.onBlockLeftClicked(world, x, y, z, player, side, xHit, yHit);
     }
 
     @Override
@@ -273,9 +273,9 @@ public class BlockStairs extends Block
     }
 
     @Override
-    public boolean blockActivated(World world, int x, int y, int z, EntityPlayer player)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced)
     {
-        return modelBlock.blockActivated(world, x, y, z, player);
+        return modelBlock.onBlockRightClicked(world, x, y, z, player, side, xPlaced, yPlaced);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/block/BlockTNT.java b/src/main/java/net/minecraft/core/block/BlockTNT.java
index ad5d66c0c..7001b63cc 100644
--- a/src/main/java/net/minecraft/core/block/BlockTNT.java
+++ b/src/main/java/net/minecraft/core/block/BlockTNT.java
@@ -7,6 +7,7 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemFirestriker;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.sound.SoundCategory;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
 
@@ -69,19 +70,19 @@ public class BlockTNT extends Block {
 	}
 
 	@Override
-	public void onBlockClicked(World world, int x, int y, int z, EntityPlayer player) {
+	public void onBlockLeftClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xHit, double yHit) {
 		if (player.getCurrentEquippedItem() != null && player.getCurrentEquippedItem().getItem() instanceof ItemFirestriker) {
 			world.setBlockMetadata(x, y, z, 1);
 		}
-		super.onBlockClicked(world, x, y, z, player);
+		super.onBlockLeftClicked(world, x, y, z, player, side, xHit, yHit);
 	}
 
 	@Override
-    public boolean blockActivated(World world, int x, int y, int z, EntityPlayer player) {
+    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced) {
 		if (player.inventory.getCurrentItem() != null && player.inventory.getCurrentItem().getItem() instanceof ItemFirestriker) {
 			ignite(world, x, y, z, player, true);
 			return true;
 		}
-		return super.blockActivated(world, x, y, z, player);
+		return super.onBlockRightClicked(world, x, y, z, player, side, xPlaced, yPlaced);
 	}
 }
diff --git a/src/main/java/net/minecraft/core/block/BlockTrapDoor.java b/src/main/java/net/minecraft/core/block/BlockTrapDoor.java
index f369ea782..a14558983 100644
--- a/src/main/java/net/minecraft/core/block/BlockTrapDoor.java
+++ b/src/main/java/net/minecraft/core/block/BlockTrapDoor.java
@@ -97,14 +97,14 @@ public class BlockTrapDoor extends Block
     }
     
     @Override
-    public void onBlockClicked(World world, int x, int y, int z, EntityPlayer player) {
+    public void onBlockLeftClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xHit, double yHit) {
     	if(!Item.hasTag(player.getCurrentEquippedItem(), ItemTags.PREVENT_LEFT_CLICK_INTERACTIONS)) {
-    		blockActivated(world, x, y, z, player);
+    		onBlockRightClicked(world, x, y, z, player, null, 0.0, 0.0);
     	}
     }
 
     @Override
-    public boolean blockActivated(World world, int x, int y, int z, EntityPlayer player)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced)
     {
         if (blockMaterial != Material.metal) {
             int l = world.getBlockMetadata(x, y, z);
diff --git a/src/main/java/net/minecraft/core/block/BlockTrommel.java b/src/main/java/net/minecraft/core/block/BlockTrommel.java
index d1a330dd1..feb818e32 100644
--- a/src/main/java/net/minecraft/core/block/BlockTrommel.java
+++ b/src/main/java/net/minecraft/core/block/BlockTrommel.java
@@ -8,6 +8,7 @@ import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
 import java.util.Random;
@@ -44,7 +45,7 @@ public class BlockTrommel extends BlockTileEntityRotatable
     }
     
     @Override
-    public boolean blockActivated(World world, int x, int y, int z, EntityPlayer player)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced)
     {
         if (!world.isClientSide) {
             TileEntityTrommel tileEntityTrommel = (TileEntityTrommel) world.getBlockTileEntity(x, y, z);
diff --git a/src/main/java/net/minecraft/core/block/BlockWorkbench.java b/src/main/java/net/minecraft/core/block/BlockWorkbench.java
index 6d17551f1..6621d0d0c 100644
--- a/src/main/java/net/minecraft/core/block/BlockWorkbench.java
+++ b/src/main/java/net/minecraft/core/block/BlockWorkbench.java
@@ -4,6 +4,7 @@ package net.minecraft.core.block;
 //            Block, Material, World, EntityPlayer
 
 import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
 
@@ -16,7 +17,7 @@ public class BlockWorkbench extends Block
     }
 
     @Override
-    public boolean blockActivated(World world, int x, int y, int z, EntityPlayer player)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced)
     {
         if (!world.isClientSide)
         {
diff --git a/src/main/java/net/minecraft/core/block/entity/TileEntitySensor.java b/src/main/java/net/minecraft/core/block/entity/TileEntitySensor.java
index 40b63c8ca..faea99ca2 100644
--- a/src/main/java/net/minecraft/core/block/entity/TileEntitySensor.java
+++ b/src/main/java/net/minecraft/core/block/entity/TileEntitySensor.java
@@ -20,10 +20,10 @@ public class TileEntitySensor extends TileEntity {
 			return 0;
 		}
 		
-		int range = 2;
+		int range = 4;
 		int blockInFront = world.getBlockId(x + facing.getOffsetX(), y + facing.getOffsetY(), z + facing.getOffsetZ());
 		if(Block.hasTag(blockInFront, BlockTags.EXTENDS_MOTION_SENSOR_RANGE)) {
-			range = 5;
+			range = 8;
 		}
 		
 		for(int i = 1; i <= range; i++) {
diff --git a/src/main/java/net/minecraft/core/block/piston/BlockPistonMoving.java b/src/main/java/net/minecraft/core/block/piston/BlockPistonMoving.java
index 12c175d21..f5c4d0778 100644
--- a/src/main/java/net/minecraft/core/block/piston/BlockPistonMoving.java
+++ b/src/main/java/net/minecraft/core/block/piston/BlockPistonMoving.java
@@ -6,6 +6,7 @@ import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.block.logic.PistonDirections;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.World;
@@ -75,7 +76,7 @@ public class BlockPistonMoving extends BlockTileEntity
     }
 
     @Override
-    public boolean blockActivated(World world, int x, int y, int z, EntityPlayer player)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced)
     {
         if(!world.isClientSide && world.getBlockTileEntity(x, y, z) == null)
         {
diff --git a/src/main/java/net/minecraft/core/entity/Entity.java b/src/main/java/net/minecraft/core/entity/Entity.java
index c7ce5292d..b2bd80477 100644
--- a/src/main/java/net/minecraft/core/entity/Entity.java
+++ b/src/main/java/net/minecraft/core/entity/Entity.java
@@ -1,9 +1,13 @@
 package net.minecraft.core.entity;
 
+import java.util.List;
+import java.util.Random;
+
 import com.mojang.nbt.CompoundTag;
 import com.mojang.nbt.DoubleTag;
 import com.mojang.nbt.FloatTag;
 import com.mojang.nbt.ListTag;
+
 import net.minecraft.client.gui.guidebook.mobs.MobInfoRegistry;
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.core.Global;
@@ -16,7 +20,6 @@ import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.lang.I18n;
-import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.AABB;
@@ -24,9 +27,7 @@ import net.minecraft.core.util.phys.Vec3d;
 import net.minecraft.core.world.IVehicle;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.data.SynchedEntityData;
-
-import java.util.List;
-import java.util.Random;
+import org.jetbrains.annotations.Nullable;
 
 public abstract class Entity
     implements IVehicle
@@ -812,7 +813,8 @@ public abstract class Entity
     	}
     	
     	int blockX = MathHelper.floor_double(x);
-    	int blockY = MathHelper.floor_double(y);
+        double d = (bb.maxY - bb.minY) * 0.66D;
+    	int blockY = MathHelper.floor_double((y - (double) heightOffset) + d);
     	int blockZ = MathHelper.floor_double(z);
     	
     	int skylight = world.getSavedLightValue(LightLayer.Sky, blockX, blockY, blockZ);
@@ -1279,7 +1281,8 @@ public abstract class Entity
     public void handlePortal(int portalTileId)
     {
     }
-    
+
+    @Nullable
     public ItemStack[] getInventory()
     {
         return null;
diff --git a/src/main/java/net/minecraft/core/entity/EntityItem.java b/src/main/java/net/minecraft/core/entity/EntityItem.java
index 0769b291d..70bb17571 100644
--- a/src/main/java/net/minecraft/core/entity/EntityItem.java
+++ b/src/main/java/net/minecraft/core/entity/EntityItem.java
@@ -25,16 +25,14 @@ import net.minecraft.core.world.World;
 public class EntityItem extends Entity
 {
 
-    public EntityItem(World world, double d, double d1, double d2,
-                      ItemStack itemstack)
-    {
+    public EntityItem(World world, double x, double y, double z, ItemStack itemstack) {
         super(world);
         age = 0;
         health = 5;
         initialRotation = (float)(java.lang.Math.random() * Math.PI * 2D);
         setSize(0.25F, 0.25F);
         heightOffset = bbHeight / 2.0F;
-        setPos(d, d1, d2);
+        setPos(x, y, z);
         item = itemstack;
         yRot = (float)(java.lang.Math.random() * 360D);
         xd = (float)(java.lang.Math.random() * 0.20000000298023224D - 0.10000000149011612D);
diff --git a/src/main/java/net/minecraft/core/item/Item.java b/src/main/java/net/minecraft/core/item/Item.java
index 88ed427ec..813f10aad 100644
--- a/src/main/java/net/minecraft/core/item/Item.java
+++ b/src/main/java/net/minecraft/core/item/Item.java
@@ -86,7 +86,7 @@ public class Item
         return this;
     }
 
-    public boolean onItemUse(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
+    public boolean onUseItemOnBlock(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
     {
         return false;
     }
@@ -96,7 +96,7 @@ public class Item
         return 1.0F;
     }
 
-    public ItemStack onItemRightClick(ItemStack itemstack, World world, EntityPlayer entityplayer)
+    public ItemStack onUseItem(ItemStack itemstack, World world, EntityPlayer entityplayer)
     {
         return itemstack;
     }
diff --git a/src/main/java/net/minecraft/core/item/ItemBed.java b/src/main/java/net/minecraft/core/item/ItemBed.java
index ab29d4272..380fc57de 100644
--- a/src/main/java/net/minecraft/core/item/ItemBed.java
+++ b/src/main/java/net/minecraft/core/item/ItemBed.java
@@ -21,7 +21,7 @@ public class ItemBed extends Item
     }
 
     @Override
-    public boolean onItemUse(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
+    public boolean onUseItemOnBlock(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
     {
     	if(!world.canPlaceInsideBlock(blockX, blockY, blockZ)) {
     		blockX += side.getOffsetX();
diff --git a/src/main/java/net/minecraft/core/item/ItemBoat.java b/src/main/java/net/minecraft/core/item/ItemBoat.java
index d0d861d16..cbea601c3 100644
--- a/src/main/java/net/minecraft/core/item/ItemBoat.java
+++ b/src/main/java/net/minecraft/core/item/ItemBoat.java
@@ -24,7 +24,7 @@ public class ItemBoat extends Item
     }
 
     @Override
-    public ItemStack onItemRightClick(ItemStack itemstack, World world, EntityPlayer entityplayer)
+    public ItemStack onUseItem(ItemStack itemstack, World world, EntityPlayer entityplayer)
     {
         float f = 1.0F;
         float f1 = entityplayer.xRotO + (entityplayer.xRot - entityplayer.xRotO) * f;
diff --git a/src/main/java/net/minecraft/core/item/ItemBow.java b/src/main/java/net/minecraft/core/item/ItemBow.java
index 6df182e85..ccedc20be 100644
--- a/src/main/java/net/minecraft/core/item/ItemBow.java
+++ b/src/main/java/net/minecraft/core/item/ItemBow.java
@@ -22,7 +22,7 @@ public class ItemBow extends Item
     }
 
     @Override
-    public ItemStack onItemRightClick(ItemStack itemstack, World world, EntityPlayer entityplayer)
+    public ItemStack onUseItem(ItemStack itemstack, World world, EntityPlayer entityplayer)
     {
         ItemStack quiverSlot = entityplayer.inventory.armorItemInSlot(2);
         if(quiverSlot != null && quiverSlot.itemID == Item.armorQuiver.id && quiverSlot.getMetadata() < quiverSlot.getMaxDamage()){
